Merge branch 'master' of feistymeow.org:feisty_meow into dev
authorChris Koeritz <fred@gruntose.com>
Fri, 10 Nov 2017 20:26:56 +0000 (15:26 -0500)
committerChris Koeritz <fred@gruntose.com>
Fri, 10 Nov 2017 20:26:56 +0000 (15:26 -0500)
production/feisty_meow_config.ini
scripts/customize/fred/fred_variables.sh
scripts/rev_control/diff_repo.sh [deleted file]
scripts/rev_control/diff_repos.sh [new file with mode: 0644]
scripts/rev_control/push_repo_downstream.sh
scripts/rev_control/version_control.sh

index 1c886420abb206c5016c96e492fc11de6d6bbf42..9deee76670da9f4ef4619e4566904ac7168b8a83 100644 (file)
@@ -3,7 +3,7 @@
 # specifies the version of the code that is being constructed here.
 major=2
 minor=140
-revision=90
+revision=91
 build=420
 
 # specifies the remainder of the version record info.
index 02e107a58d79c4c83008e424c4bac61dbdb7518c..4c9c0d90d2c8bb63088454bf258653760d3a83a8 100644 (file)
@@ -38,15 +38,21 @@ if [ -z "$USER_CUSTOMIZATIONS_LOADED" ]; then
 #  export BROWSER=/usr/bin/firefox
 
   # editor and other mixed settings...
-  export EDITOR="$(which vim)"
+  export EDITOR="$(which gvim)"
+  if [ -z "$EDITOR" ]; then
+    export EDITOR="$(which vim)"
+  else
+    # special case for gvim; tell it not to fork or we can't wait for it.
+    EDITOR+=" --nofork"
+  fi
   if [ -z "$EDITOR" ]; then
     EDITOR="$(which vi)"
-    if [ -z "$EDITOR" ]; then
-      EDITOR="$(which emacs)"
-      if [ -z "$EDITOR" ]; then
-        echo "Cannot find a friendly editor."
-      fi
-    fi
+  fi
+  if [ -z "$EDITOR" ]; then
+    EDITOR="$(which emacs)"
+  fi
+  if [ -z "$EDITOR" ]; then
+    echo "Cannot find a friendly editor."
   fi
   export VISUAL="$EDITOR"
   # the editors for revision control must wait while document is edited,
diff --git a/scripts/rev_control/diff_repo.sh b/scripts/rev_control/diff_repo.sh
deleted file mode 100644 (file)
index eb02719..0000000
+++ /dev/null
@@ -1,25 +0,0 @@
-#!/bin/bash
-
-# does differences on a set of folders checked out from subversion or git.
-# this can take a directory as parameter, but will default to the current
-# working directory.  all the directories under the passed directory will
-# be examined.
-
-source "$FEISTY_MEOW_SCRIPTS/core/launch_feisty_meow.sh"
-source "$FEISTY_MEOW_SCRIPTS/rev_control/version_control.sh"
-
-##############
-
-dir="$1"; shift
-if [ -z "$dir" ]; then
-  dir=.
-fi
-
-pushd "$dir" &>/dev/null
-test_or_die "changing to directory: $dir"
-tempfile=$(generate_rev_ctrl_filelist)
-popd &>/dev/null
-
-perform_revctrl_action_on_file "$tempfile" do_diff
-test_or_die "performing revision control action do_diff on: $tempfile"
-
diff --git a/scripts/rev_control/diff_repos.sh b/scripts/rev_control/diff_repos.sh
new file mode 100644 (file)
index 0000000..eb02719
--- /dev/null
@@ -0,0 +1,25 @@
+#!/bin/bash
+
+# does differences on a set of folders checked out from subversion or git.
+# this can take a directory as parameter, but will default to the current
+# working directory.  all the directories under the passed directory will
+# be examined.
+
+source "$FEISTY_MEOW_SCRIPTS/core/launch_feisty_meow.sh"
+source "$FEISTY_MEOW_SCRIPTS/rev_control/version_control.sh"
+
+##############
+
+dir="$1"; shift
+if [ -z "$dir" ]; then
+  dir=.
+fi
+
+pushd "$dir" &>/dev/null
+test_or_die "changing to directory: $dir"
+tempfile=$(generate_rev_ctrl_filelist)
+popd &>/dev/null
+
+perform_revctrl_action_on_file "$tempfile" do_diff
+test_or_die "performing revision control action do_diff on: $tempfile"
+
index 84214b70a58b04f05423a029420ff76ef7c6e527..ef1bb35a6a49b553c992c08050e62da419afef70 100644 (file)
@@ -47,6 +47,18 @@ test_or_die "changing to directory: $dir"
 git fetch origin
 test_or_die "running git fetch origin"
 
+
+#these are all shots in the dark.
+# use our careful updater!
+
+git remote update
+
+# get everything from the origin.
+git fetch --all
+
+# merge the changes in.
+git merge --no-ff --all
+
 # turn off occasionally troublesome setting before checkin.
 unset GIT_SSH
 
index 0a6ee8fe73d0a99761695d35a08e5325715a7ee5..1224480f3823fe27a3ec7c6a8e79ebbc689b707b 100644 (file)
@@ -9,8 +9,6 @@
 source "$FEISTY_MEOW_SCRIPTS/core/launch_feisty_meow.sh"
 source "$FEISTY_MEOW_SCRIPTS/tty/terminal_titler.sh"
 
-#hmmm: we need to dump all the outputs in this script into splitter
-
 ##############
 
 # the maximum depth that the recursive functions will try to go below the starting directory.
@@ -78,10 +76,7 @@ function do_checkin()
     if test_writeable ".git"; then
       $blatt
 
-# classic implementation, but only works with one master branch.
-# fixes will be forthcoming from development branch.
-
-      # snag all new files.  not to everyone's liking.
+      # put all changed and new files in the commit.  not to everyone's liking.
       git add --all .
       test_or_die "git add all new files"
 
@@ -91,10 +86,17 @@ function do_checkin()
         git commit .
         test_or_die "git commit"
       fi
-      # upload the files to the server so others can see them.
-      git push 2>&1 | grep -v "X11 forwarding request failed"
-      if [ ${PIPESTATUS[0]} -ne 0 ]; then false; fi
+
+      # a new set of steps we have to take to make sure the branch integrity is good.
+      do_careful_git_update 
+
+      # we continue on to the push, even if there were no changes this time, because
+      # there could already be committed changes that haven't been pushed yet.
+
+      # upload any changes to the upstream repo so others can see them.
+      git push origin "$(my_branch_name)" 2>&1 | grep -v "X11 forwarding request failed" | $TO_SPLITTER
       test_or_die "git push"
+
     fi
   else
     # nothing there.  it's not an error though.
@@ -104,7 +106,7 @@ function do_checkin()
 
   restore_terminal_title
 
-  true;
+  return 0
 }
 
 # shows the local changes in a repository.
@@ -132,7 +134,7 @@ function do_diff
 
   restore_terminal_title
 
-  true;
+  return 0
 }
 
 # reports any files that are not already known to the upstream repository.
@@ -160,7 +162,7 @@ function do_report_new
 
   restore_terminal_title
 
-  true
+  return 0
 }
 
 # checks in all the folders in a specified list.
@@ -217,17 +219,101 @@ function squash_first_few_crs()
   fi
 }
 
+#hmmm: the below are git specific and should be named that way.
+
+function all_branch_names()
+{
+  echo "$(git branch -vv | cut -d ' ' -f2)"
+}
+
 # a helpful method that reports the git branch for the current directory's
 # git repository.
 function my_branch_name()
 {
-  echo "$(git branch | grep \* | cut -d ' ' -f2)"
+  echo "$(git branch -vv | grep '\*' | cut -d ' ' -f2)"
 }
 
+#this had a -> in it at one point for not matching, didn't it?
 # this reports the upstream branch for the current repo.
-function parent_branch_name()
+##function parent_branch_name()
+##{
+  ##echo "$(git branch -vv | grep \* | cut -d ' ' -f2)"
+##}
+
+# this exits with 0 for success (normal bash behavior) when up to date.  if the branch is not up to date,
+# then these values are returned:
+#DOCUMENT THE VALUES
+# reference: https://stackoverflow.com/questions/3258243/check-if-pull-needed-in-git
+function check_branch_state()
+{
+  local branch="$1"; shift
+
+  local to_return=120  # unknown issue.
+
+sep
+
+  LOCAL=$(git rev-parse @)
+  REMOTE=$(git rev-parse "$branch")
+  BASE=$(git merge-base @ "$branch")
+var branch LOCAL REMOTE BASE
+
+  if [ "$LOCAL" == "$REMOTE" ]; then
+    echo "Up-to-date"
+    to_return=0
+  elif [ "$LOCAL" == "$BASE" ]; then
+    echo "Need to pull"
+    to_return=1
+  elif [ "$REMOTE" == "$BASE" ]; then
+    echo "Need to push"
+    to_return=2
+  else
+    echo "Diverged"
+    to_return=3
+  fi
+
+sep
+
+  return $to_return
+}
+
+# the git update process just gets more and more complex when you bring in
+# branches, so we've moved this here to avoid having a ton of code in the
+# other methods.
+function do_careful_git_update()
 {
-  echo "$(git branch -vv | grep \* | cut -d ' ' -f2)"
+  local this_branch="$(my_branch_name)"
+
+#proposition: this step didn't help before, and it seems redundant now.
+#...
+#hmmm, maybe it is needed.  and people did seem to want it first, so trying that.
+  # first update all our remote branches to their current state from the repos.
+  git remote update
+  test_or_die "git remote update"
+
+#appears to be useless; reports no changes when we need to know about remote changes that do exist:
+#  check_branch_state "$this_branch"
+#  state=$?
+#  test_or_continue "branch state check"
+#  echo the branch state is $state
+
+  # this code is now doing what i have to do when i repair the repo.  and it seems to be good so far.
+  local branch_list=$(all_branch_names)
+  local bran
+  for bran in $branch_list; do
+#    echo "synchronizing remote branch: $bran"
+    git checkout "$bran"
+    test_or_die "git checking out remote branch: $bran"
+    git pull --no-ff
+    test_or_die "git pull of remote branch: $bran"
+  done
+  # now switch back to our branch.
+  git checkout "$this_branch"
+  test_or_die "git checking out our current branch: $this_branch"
+
+  # now pull down any changes in our own origin in the repo, to stay in synch
+  # with any changes from others.
+  git pull --no-ff --all
+  test_or_die "git pulling all upstream"
 }
 
 # gets the latest versions of the assets from the upstream repository.
@@ -260,14 +346,9 @@ function do_update()
   elif [ -d ".git" ]; then
     if test_writeable ".git"; then
       $blatt
-
-# classic implementation, but only works with one master branch.
-# fixes will be forthcoming from development branch.
-
-      git pull 2>&1 | grep -v "X11 forwarding request failed" | $TO_SPLITTER
+      git pull --no-ff 2>&1 | grep -v "X11 forwarding request failed" | $TO_SPLITTER
       if [ ${PIPESTATUS[0]} -ne 0 ]; then false; fi
-      test_or_die "git pull"
-
+      test_or_die "git pull of origin without fast forwards"
     fi
   else
     # this is not an error necessarily; we'll just pretend they planned this.
@@ -277,7 +358,7 @@ function do_update()
 
   restore_terminal_title
 
-  true
+  return 0
 }
 
 # gets all the updates for a list of folders under revision control.
@@ -350,8 +431,14 @@ function perform_revctrl_action_on_file()
 
   save_terminal_title
 
+  local did_anything=
+
   while read -u 3 dirname; do
-    if [ -z "$dirname" ]; then continue; fi
+    if [ -z "$dirname" ]; then
+      # we often have blank lines in the input file for some reason.
+      continue
+    fi
+    did_anything=yes
     pushd "$dirname" &>/dev/null
     echo "[$(pwd)]"
     $action .
@@ -360,6 +447,10 @@ function perform_revctrl_action_on_file()
     popd &>/dev/null
   done 3<"$tempfile"
 
+  if [ -z "$did_anything" ]; then
+    echo "There was nothing to do the action '$action' on."
+  fi
+
   restore_terminal_title
 
   rm $tempfile